<?php

	require_once(TOOLKIT . '/class.datasource.php');
	
	Class datasourcetranslation_configuration extends Datasource{
		
		public $dsParamROOTELEMENT = 'translation-configuration';
		public $dsParamORDER = 'desc';
		public $dsParamLIMIT = '1000';
		public $dsParamREDIRECTONEMPTY = 'no';
		public $dsParamPARAMOUTPUT = 'group';
		public $dsParamSORT = 'system:id';
		public $dsParamSTARTPAGE = '1';
		public $dsParamHTMLENCODE = 'yes';
		public $dsParamASSOCIATEDENTRYCOUNTS = 'no';
		public $dsParamINCLUDEDELEMENTS = array(
				'system:pagination',
				'group',
				'key',
				'value'
		);

		public function __construct(&$parent, $env=NULL, $process_params=true){
			parent::__construct($parent, $env, $process_params);
			$this->_dependencies = array();
		}
		
		public function about(){
			return array(
					 'name' => 'Translation / configuration',
					 'author' => array(
							'name' => 'lexa yo',
							'website' => 'http://demos.silexlabs.org/symphony/admin',
							'email' => 'a.hoyau@silexlabs.org'),
					 'version' => '1.0',
					 'release-date' => '2010-11-19T09:48:55+00:00');	
		}
		
		public function getSource(){
			return '5';
		}
		
		public function allowEditorToParse(){
			return true;
		}
		
		public function grab(&$param_pool=NULL){
			$result = new XMLElement($this->dsParamROOTELEMENT);
				
			try{
				include(TOOLKIT . '/data-sources/datasource.section.php');
			}
			catch(FrontendPageNotFoundException $e){
				// Work around. This ensures the 404 page is displayed and
				// is not picked up by the default catch() statement below
				FrontendPageNotFoundExceptionHandler::render($e);
			}			
			catch(Exception $e){
				$result->appendChild(new XMLElement('error', $e->getMessage()));
				return $result;
			}	

			if($this->_force_empty_result) $result = $this->emptyXMLSet();
			return $result;
		}
	}

